import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.security.SecureRandom;


public class XKCD {

	/**
	 * @param args
	 */
	
	public static void main(String[] args) {
		int erg = 600;
		
		while(true) {
			String urlParameters = null;
			SecureRandom random = new SecureRandom();
			try {
				urlParameters = "hashable=" + URLEncoder.encode(new BigInteger(130, random).toString(32), "UTF-8");
			} catch (UnsupportedEncodingException e1) {
				e1.printStackTrace();
			}
		
			URL url;
		    HttpURLConnection connection = null;  
		    try {
		      //Create connection
		      url = new URL("http://almamater.xkcd.com/?edu=kit.edu");
		      connection = (HttpURLConnection)url.openConnection();
		      connection.setRequestMethod("POST");
		      connection.setRequestProperty("Content-Type", 
		           "application/x-www-form-urlencoded");
					
		      connection.setRequestProperty("Content-Length", "" + 
		               Integer.toString(urlParameters.getBytes().length));
		      connection.setRequestProperty("Content-Language", "en-US");  
					
		      connection.setUseCaches (false);
		      connection.setDoInput(true);
		      connection.setDoOutput(true);
	
		      //Send request
		      DataOutputStream wr = new DataOutputStream (
		                  connection.getOutputStream ());
		      wr.writeBytes (urlParameters);
		      wr.flush ();
		      wr.close ();
	
		      //Get Response	
		      InputStream is = connection.getInputStream();
		      BufferedReader rd = new BufferedReader(new InputStreamReader(is));
		      String line;
		      StringBuffer response = new StringBuffer(); 
		      while((line = rd.readLine()) != null) {
		        response.append(line);
		        response.append('\r');
		      }
		      rd.close();

		      int tempErg = Integer.parseInt(response.substring(response.indexOf("It is off by ")+"It is off by ".length(), response.indexOf(" bits.")));
		      if(tempErg < erg) {
		    	  erg = tempErg;
		    	  System.out.println(erg);
		      }
		      
	
		    } catch (Exception e) {
	
		      e.printStackTrace();
		      
	
		    } finally {
	
		      if(connection != null) {
		        connection.disconnect(); 
		      }
		    }	
		}
	}
}
